  program proboj;
    uses hrac1,hrac2,hrac3,hrac4,hrac5,grafika,typy,crt;

{############################################################################}
{########################< VNUTORNE POLIA >##################################}
{############################################################################}

    var {Ktori hraci uz hrali}
        Hrali:array[1..Hracov,1..Hracov] of integer;
        {Vysledky}
        Vysle:Vysledok;
        {Tahy jednotlivych hracov}
        Tahaj:array[1..Hracov] of ProcTahaj;
        Init:array[1..Hracov] of ProcInit;
        {Ihrisko}
        D_Ihrisko:Ihrisko;
        {Panacikovia oboch hracov}
        D_Panaciky:array[1..2] of Panaciky;
        {Ktory hraci prave hraju}
        H:array [1..2] of integer;
        B:array [1..2] of integer;
        {Kolko este maju zivych hracov}
        Zivych:array[1..2] of integer;

{############################################################################}
{########################<    PROCEDURY    >#################################}
{############################################################################}
    function Silnejsi(Co,Kam:integer):boolean;
      begin
        case Co of
          {Najslabsia figurka}
          1:Silnejsi:=(Kam=1)or(Kam=Panacikov);
          {Ostatne figurky}
          2..(Panacikov-1):Silnejsi:=(Kam<=Co);
          {Najsilnejsia figurka}
          Panacikov:Silnejsi:=(Kam>1);
        end;
      end;

    function MozeSaPosunut(ox,oy,nx,ny:integer):boolean;
      begin
        MozeSaPosunut:={Nevybehne z planiku}
                       (nx>=1)and(nx<=IhriskoX)and(ny>=1)and(ny<=IhriskoY)and
                       (
                         {Bud tam nic nie je}
                         (D_Ihrisko[nx,ny].Fig=0)or
                         {Je tam slabsi super}
                         (Silnejsi(D_Ihrisko[ox,oy].Fig,D_Ihrisko[nx,ny].Fig))or
                         {Je tam vlastna figurka}
                         (D_Ihrisko[nx,ny].Hrac=D_Ihrisko[ox,oy].Hrac)
                       );
      end;

    {Urob jeden tah}
    procedure JedenTah;
      var i,j,k,l,m:integer;
          nx,ny,ox,oy:array[1..Panacikov] of integer;
          Kam:Pohyby;
          mvm:boolean;

      begin
        for i:=1 to 2 do begin
          {Nastal pohyb?}
          mvm:=false;
          {Nech potiahne:}
          Tahaj[H[i]](D_Panaciky[3-i],D_Panaciky[i],Kam);
          {Teraz potiahneme jeho panacikov - vypocitame nove suradnice}
          for j:=1 to Panacikov do begin
            if D_Panaciky[i][j].zivy then begin
              {Zisti, kam sa posunie}
              ox[j]:=D_Panaciky[i][j].px;
              oy[j]:=D_Panaciky[i][j].py;
              if (kam[j]>=0) and (Kam[j]<=3) then begin
                {Kam chce ist}
                nx[j]:=ox[j]+Smery[Kam[j]].x;
                ny[j]:=oy[j]+Smery[Kam[j]].y;
                {Moze s posunut?}
                if not MozeSaPosunut(ox[j],oy[j],nx[j],ny[j]) then begin
                  nx[j]:=ox[j];
                  ny[j]:=oy[j];
                end else
                  {Bomba -> pohne sa}
                  mvm:=true;
              end else begin
                nx[j]:=ox[j];
                ny[j]:=oy[j];
              end;
            end;
          end;
          {Vyhod superove figurku na policku}
          for j:=1 to Panacikov do begin
            if D_Panaciky[i][j].zivy then begin
              if (nx[j]<>ox[j]) or (ny[j]<>oy[j]) then begin
                if (D_Ihrisko[nx[j],ny[j]].Hrac<>D_Ihrisko[ox[j],oy[j]].Hrac) and (D_Ihrisko[nx[j],ny[j]].Hrac<>0) then begin
                  {Vyhodime jedneho panacika}
                  Zivych[3-i]:=Zivych[3-i]-1;
                  D_Panaciky[3-i][D_Ihrisko[nx[j],ny[j]].Fig].Zivy:=false;
                  VymazPanacika(H[3-i],nx[j],ny[j]);
                  D_Ihrisko[nx[j],ny[j]].Hrac:=0;
                  D_Ihrisko[nx[j],ny[j]].Fig:=0;
                end;
              end;
            end;
          end;
          {Zabijeme vsetkych na rovnakych polickach - BUBUBU takto sa neprogramuje}
          for k:=1 to Panacikov-1 do if (D_Panaciky[i][k].Zivy) then begin
            m:=0;
            {Spocitame takych s rovnakou suradnicou}
            for l:=k+1 to Panacikov do if (D_Panaciky[i][l].Zivy) and (nx[l]=nx[k]) and (ny[l]=ny[k]) then m:=m+1;
            {Ak m>0 tak ich zabijeme}
            if (m>0) then
              for l:=1 to Panacikov do if (D_Panaciky[i][l].Zivy) and (nx[l]=nx[k]) and (ny[l]=ny[k]) then begin
                Zivych[i]:=Zivych[i]-1;
                D_Panaciky[i][l].Zivy:=false;
                D_Ihrisko[ox[l],oy[l]].Hrac:=0;
                D_Ihrisko[ox[l],oy[l]].Fig:=0;
                VymazPanacika(H[i],ox[l],oy[l]);
              end;
          end;
          {Teraz realizujeme tahy - VYMAZ}
          for j:=1 to Panacikov do if D_Panaciky[i][j].zivy then begin
            if (nx[j]<>ox[j]) or (ny[j]<>oy[j]) then begin
              D_Ihrisko[ox[j],oy[j]].Hrac:=0;
              D_Ihrisko[ox[j],oy[j]].Fig:=0;
              VymazPanacika(H[i],ox[j],oy[j]);
            end;
          end;
          {Teraz realizujeme tahy - NAMAZ}
          for j:=1 to Panacikov do if D_Panaciky[i][j].zivy then begin
            if (nx[j]<>ox[j]) or (ny[j]<>oy[j]) then begin
              D_Ihrisko[nx[j],ny[j]].Hrac:=H[i];
              D_Ihrisko[nx[j],ny[j]].Fig:=j;
              D_Panaciky[i][j].px:=nx[j];
              D_Panaciky[i][j].py:=ny[j];
              NakresliPanacika(H[i],nx[j],ny[j],D_Ihrisko[nx[j],ny[j]].Fig);
            end;
          end;
{          if mvm then delay(100);}
        end;
      end;

   {Je uz koniec hry?}
   function Koniec:boolean;
     begin
       Koniec:=not((Zivych[1]>0)and(Zivych[2]>0));
     end;

   {Odohraj jednu hru}
   procedure Hra;
     var i:integer;
         g:char;
     begin
       Init[H[1]];
       Init[H[2]];

       i:=1;
       repeat until readkey=' ';

       while (i<TahovNaHru) and (not Koniec) do begin
         Jedentah;
         if keypressed then begin
           g:=readkey;
           if g=#13 then i:=TahovNaHru;
         end;
         inc(i);
       end;
     end;

   {Daj i-teho panacika hraca h na policko x,y smerom s}
   procedure Dajna(j,i,x,y:integer);
     begin
       D_Ihrisko[x,y].Hrac:=H[j];
       D_Ihrisko[x,y].Fig:=i;
       D_Panaciky[j][i].zivy:=true;
       D_Panaciky[j][i].Px:=x;
       D_Panaciky[j][i].Py:=y;
       NakresliPanacika(H[j],x,y,i);
     end;

   {Odohraj Turnaj}
   procedure Turnaj;
     label 1;
     var i,j,t:integer;
         jx,jy:array[1..16] of integer;

     procedure Vyhodnot;
       begin
         if Zivych[1]>Zivych[2] then
	   B[1]:=B[1]+3+(Zivych[1] div 2)
	 else
	  if Zivych[1]<Zivych[2] then
	     B[2]:=B[2]+3+(Zivych[2] div 2)
	  else begin
            B[1]:=B[1]+1;
            B[2]:=B[2]+1;
          end;
       end;

     procedure Init;
       var i,j:integer;
       begin
         {Vycisti ihrisko}
         NakresliIhrisko;
         Zivych[1]:=Panacikov;
         Zivych[2]:=Panacikov;
         for i:=1 to IhriskoX do
           for j:=1 to IhriskoY do begin
             D_Ihrisko[i,j].Hrac:=0;
             D_Ihrisko[i,j].Fig:=0;
           end;
       end;

     begin
       for i:=1 to 16 do begin
         1:
         jx[i]:=random(16)+1;
         jy[i]:=random(16)+1;
         for j:=1 to i-1 do if (jx[i]=jx[j]) and (jy[i]=jy[j]) then goto 1;
       end;

       {Vynuluj Pole}
       for i:=1 to Hracov do for j:=1 to Hracov do begin
         Hrali[i,j]:=0;
       end;
       {Hraj}
       for t:=1 to Hracov*(Hracov-1) div 2 do begin
         {Kto s kym?}
         repeat
           H[1]:=random(Hracov)+1;
           H[2]:=random(Hracov)+1;
         until (H[1]<>H[2]) and (Hrali[H[1],H[2]]=0);
         Hrali[H[1],H[2]]:=1;
         Hrali[H[2],H[1]]:=1;

         {Vynuluj body}
         B[1]:=0;
         B[2]:=0;

         {Oznam zapas}
         OznamZapas(H[1],H[2]);

         repeat until readkey=' ';
         {Idu hrat Niekolko druhov zapasov}

         {Druh1 - Sachovy zaciatok - TAK}
         Init;
         for j:=1 to Panacikov do begin
           Dajna(1,j,jx[j],jy[j]);
           Dajna(2,j,jx[j+8],jy[j+8]);
         end;
         {Zahraj hru}
         Hra;
         {Vyhodnot}
         Vyhodnot;
         OznamVysledok(H[1],H[2],B[1],B[2],' Prieben stav: ');
         repeat until readkey=' ';

         i:=B[1]; B[1]:=B[2]; B[2]:=i;
         i:=H[1]; H[1]:=H[2]; H[2]:=i;

         {Druh2 - Sachovy zaciatok - INAK}
         Init;
         for j:=1 to Panacikov do begin
           Dajna(1,j,jx[j],jy[j]);
           Dajna(2,j,jx[j+8],jy[j+8]);
         end;
         {Zahraj hru}
         Hra;
         {Vyhodnot}
         Vyhodnot;
         OznamVysledok(H[1],H[2],B[1],B[2],' Koncov stav: ');
         repeat until readkey=' ';

         Vysle[H[1]][H[2]]:=B[1];
         Vysle[H[2]][H[1]]:=B[2];
       end;

       KoniecTurnaja(Vysle);
       repeat until readkey=' ';
     end;

  begin
    randomize;
    Tahaj[1]:=Hrac1.Tahaj;
    Tahaj[2]:=Hrac2.Tahaj;
    Tahaj[3]:=Hrac3.Tahaj;
    Tahaj[4]:=Hrac4.Tahaj;
    Tahaj[5]:=Hrac5.Tahaj;
    Init[1]:=Hrac1.Init;
    Init[2]:=Hrac2.Init;
    Init[3]:=Hrac3.Init;
    Init[4]:=Hrac4.Init;
    Init[5]:=Hrac5.Init;
    Turnaj;
  end.